diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/capabilities.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/capabilities.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/capabilities.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/capabilities.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 108,114 ****
  
  		$this->role_objects = array();
  		$this->role_names =  array();
! 		foreach ( (array) $this->roles as $role => $data ) {
  			$this->role_objects[$role] = new WP_Role( $role, $this->roles[$role]['capabilities'] );
  			$this->role_names[$role] = $this->roles[$role]['name'];
  		}
--- 108,144 ----
  
  		$this->role_objects = array();
  		$this->role_names =  array();
! 		foreach ( array_keys( $this->roles ) as $role ) {
! 			$this->role_objects[$role] = new WP_Role( $role, $this->roles[$role]['capabilities'] );
! 			$this->role_names[$role] = $this->roles[$role]['name'];
! 		}
! 	}
! 
! 	/**
! 	 * Reinitialize the object
! 	 *
! 	 * Recreates the role objects. This is typically called only by switch_to_blog()
! 	 * after switching wpdb to a new blog ID.
! 	 *
! 	 * @since 3.5.0
! 	 * @access public
! 	 */
! 	function reinit() {
! 		// There is no need to reinit if using the wp_user_roles global.
! 		if ( ! $this->use_db )
! 			return;
! 
! 		global $wpdb, $wp_user_roles;
! 
! 		// Duplicated from _init() to avoid an extra function call.
! 		$this->role_key = $wpdb->prefix . 'user_roles';
! 		$this->roles = get_option( $this->role_key );
! 		if ( empty( $this->roles ) )
! 			return;
! 
! 		$this->role_objects = array();
! 		$this->role_names =  array();
! 		foreach ( array_keys( $this->roles ) as $role ) {
  			$this->role_objects[$role] = new WP_Role( $role, $this->roles[$role]['capabilities'] );
  			$this->role_names[$role] = $this->roles[$role]['name'];
  		}
***************
*** 176,181 ****
--- 206,214 ----
  	 * @param bool $grant Optional, default is true. Whether role is capable of performing capability.
  	 */
  	function add_cap( $role, $cap, $grant = true ) {
+ 		if ( ! isset( $this->roles[$role] ) )
+ 			return;
+ 
  		$this->roles[$role]['capabilities'][$cap] = $grant;
  		if ( $this->use_db )
  			update_option( $this->role_key, $this->roles );
***************
*** 191,196 ****
--- 224,232 ----
  	 * @param string $cap Capability name.
  	 */
  	function remove_cap( $role, $cap ) {
+ 		if ( ! isset( $this->roles[$role] ) )
+ 			return;
+ 
  		unset( $this->roles[$role]['capabilities'][$cap] );
  		if ( $this->use_db )
  			update_option( $this->role_key, $this->roles );
***************
*** 233,240 ****
  	 * @param string $role Role name to look up.
  	 * @return bool
  	 */
! 	function is_role( $role )
! 	{
  		return isset( $this->role_names[$role] );
  	}
  }
--- 269,275 ----
  	 * @param string $role Role name to look up.
  	 * @return bool
  	 */
! 	function is_role( $role ) {
  		return isset( $this->role_names[$role] );
  	}
  }
***************
*** 430,436 ****
  	 * @since 2.0.0
  	 * @access public
  	 *
! 	 * @param int|string $id User's ID
  	 * @param string $name Optional. User's username
  	 * @param int $blog_id Optional Blog ID, defaults to current blog.
  	 * @return WP_User
--- 465,471 ----
  	 * @since 2.0.0
  	 * @access public
  	 *
! 	 * @param int|string|stdClass|WP_User $id User's ID, a WP_User object, or a user object from the DB.
  	 * @param string $name Optional. User's username
  	 * @param int $blog_id Optional Blog ID, defaults to current blog.
  	 * @return WP_User
***************
*** 448,453 ****
--- 483,496 ----
  			);
  		}
  
+ 		if ( is_a( $id, 'WP_User' ) ) {
+ 			$this->init( $id->data, $blog_id );
+ 			return;
+ 		} elseif ( is_object( $id ) ) {
+ 			$this->init( $id, $blog_id );
+ 			return;
+ 		}
+ 
  		if ( ! empty( $id ) && ! is_numeric( $id ) ) {
  			$name = $id;
  			$id = 0;
***************
*** 636,641 ****
--- 679,695 ----
  		return $this->__isset( $key );
  	}
  
+ 	/*
+ 	 * Return an array representation.
+ 	 *
+ 	 * @since 3.5.0
+ 	 *
+ 	 * @return array Array representation.
+ 	 */
+ 	function to_array() {
+ 		return get_object_vars( $this->data );
+ 	}
+ 
  	/**
  	 * Set up capability object properties.
  	 *
***************
*** 685,691 ****
  
  		//Filter out caps that are not role names and assign to $this->roles
  		if ( is_array( $this->caps ) )
! 			$this->roles = array_filter( array_keys( $this->caps ), array( &$wp_roles, 'is_role' ) );
  
  		//Build $allcaps from role caps, overlay user's $caps
  		$this->allcaps = array();
--- 739,745 ----
  
  		//Filter out caps that are not role names and assign to $this->roles
  		if ( is_array( $this->caps ) )
! 			$this->roles = array_filter( array_keys( $this->caps ), array( $wp_roles, 'is_role' ) );
  
  		//Build $allcaps from role caps, overlay user's $caps
  		$this->allcaps = array();
***************
*** 743,754 ****
  	 * @param string $role Role name.
  	 */
  	function set_role( $role ) {
  		foreach ( (array) $this->roles as $oldrole )
  			unset( $this->caps[$oldrole] );
  
- 		if ( 1 == count( $this->roles ) && $role == $this->roles[0] )
- 			return;
- 
  		if ( !empty( $role ) ) {
  			$this->caps[$role] = true;
  			$this->roles = array( $role => true );
--- 797,808 ----
  	 * @param string $role Role name.
  	 */
  	function set_role( $role ) {
+ 		if ( 1 == count( $this->roles ) && $role == current( $this->roles ) )
+ 			return;
+ 
  		foreach ( (array) $this->roles as $oldrole )
  			unset( $this->caps[$oldrole] );
  
  		if ( !empty( $role ) ) {
  			$this->caps[$role] = true;
  			$this->roles = array( $role => true );
***************
*** 828,834 ****
  	 * @param string $cap Capability name.
  	 */
  	function remove_cap( $cap ) {
! 		if ( empty( $this->caps[$cap] ) )
  			return;
  		unset( $this->caps[$cap] );
  		update_user_meta( $this->ID, $this->cap_key, $this->caps );
--- 882,888 ----
  	 * @param string $cap Capability name.
  	 */
  	function remove_cap( $cap ) {
! 		if ( ! isset( $this->caps[$cap] ) )
  			return;
  		unset( $this->caps[$cap] );
  		update_user_meta( $this->ID, $this->cap_key, $this->caps );
***************
*** 947,966 ****
  		$caps[] = 'promote_users';
  		break;
  	case 'edit_user':
  		// Allow user to edit itself
! 		if ( isset( $args[0] ) && $user_id == $args[0] )
  			break;
! 		// Fall through
! 	case 'edit_users':
  		// If multisite these caps are allowed only for super admins.
  		if ( is_multisite() && !is_super_admin( $user_id ) )
  			$caps[] = 'do_not_allow';
  		else
! 			$caps[] = 'edit_users'; // Explicit due to primitive fall through
  		break;
  	case 'delete_post':
  	case 'delete_page':
- 		$author_data = get_userdata( $user_id );
  		$post = get_post( $args[0] );
  
  		if ( 'revision' == $post->post_type ) {
--- 1001,1019 ----
  		$caps[] = 'promote_users';
  		break;
  	case 'edit_user':
+ 	case 'edit_users':
  		// Allow user to edit itself
! 		if ( 'edit_user' == $cap && isset( $args[0] ) && $user_id == $args[0] )
  			break;
! 
  		// If multisite these caps are allowed only for super admins.
  		if ( is_multisite() && !is_super_admin( $user_id ) )
  			$caps[] = 'do_not_allow';
  		else
! 			$caps[] = 'edit_users'; // edit_user maps to edit_users.
  		break;
  	case 'delete_post':
  	case 'delete_page':
  		$post = get_post( $args[0] );
  
  		if ( 'revision' == $post->post_type ) {
***************
*** 977,988 ****
  			break;
  		}
  
! 		if ( '' != $post->post_author ) {
! 			$post_author_data = get_userdata( $post->post_author );
! 		} else {
! 			// No author set yet, so default to current user for cap checks.
! 			$post_author_data = $author_data;
! 		}
  
  		// If the user is the author...
  		if ( is_object( $post_author_data ) && $user_id == $post_author_data->ID ) {
--- 1030,1042 ----
  			break;
  		}
  
! 		$post_author_id = $post->post_author;
! 
! 		// If no author set yet, default to current user for cap checks.
! 		if ( ! $post_author_id )
! 			$post_author_id = $user_id;
! 
! 		$post_author_data = $post_author_id == get_current_user_id() ? wp_get_current_user() : get_userdata( $post_author_id );
  
  		// If the user is the author...
  		if ( is_object( $post_author_data ) && $user_id == $post_author_data->ID ) {
***************
*** 1010,1016 ****
  		// edit_others_posts
  	case 'edit_post':
  	case 'edit_page':
- 		$author_data = get_userdata( $user_id );
  		$post = get_post( $args[0] );
  
  		if ( 'revision' == $post->post_type ) {
--- 1064,1069 ----
***************
*** 1027,1040 ****
  			break;
  		}
  
! 		if ( '' != $post->post_author ) {
! 			$post_author_data = get_userdata( $post->post_author );
! 		} else {
! 			// No author set yet, so default to current user for cap checks.
! 			$post_author_data = $author_data;
! 		}
  
- 		//echo "current user id : $user_id, post author id: " . $post_author_data->ID . "<br />";
  		// If the user is the author...
  		if ( is_object( $post_author_data ) && $user_id == $post_author_data->ID ) {
  			// If the post is published...
--- 1080,1093 ----
  			break;
  		}
  
! 		$post_author_id = $post->post_author;
! 
! 		// If no author set yet, default to current user for cap checks.
! 		if ( ! $post_author_id )
! 			$post_author_id = $user_id;
! 
! 		$post_author_data = $post_author_id == get_current_user_id() ? wp_get_current_user() : get_userdata( $post_author_id );
  
  		// If the user is the author...
  		if ( is_object( $post_author_data ) && $user_id == $post_author_data->ID ) {
  			// If the post is published...
***************
*** 1059,1065 ****
  		break;
  	case 'read_post':
  	case 'read_page':
- 		$author_data = get_userdata( $user_id );
  		$post = get_post( $args[0] );
  
  		if ( 'revision' == $post->post_type ) {
--- 1112,1117 ----
***************
*** 1082,1093 ****
  			break;
  		}
  
! 		if ( '' != $post->post_author ) {
! 			$post_author_data = get_userdata( $post->post_author );
! 		} else {
! 			// No author set yet, so default to current user for cap checks.
! 			$post_author_data = $author_data;
! 		}
  
  		if ( is_object( $post_author_data ) && $user_id == $post_author_data->ID )
  			$caps[] = $post_type->cap->read;
--- 1134,1146 ----
  			break;
  		}
  
! 		$post_author_id = $post->post_author;
! 
! 		// If no author set yet, default to current user for cap checks.
! 		if ( ! $post_author_id )
! 			$post_author_id = $user_id;
! 
! 		$post_author_data = $post_author_id == get_current_user_id() ? wp_get_current_user() : get_userdata( $post_author_id );
  
  		if ( is_object( $post_author_data ) && $user_id == $post_author_data->ID )
  			$caps[] = $post_type->cap->read;
***************
*** 1096,1101 ****
--- 1149,1160 ----
  		else
  			$caps = map_meta_cap( 'edit_post', $user_id, $post->ID );
  		break;
+ 	case 'publish_post':
+ 		$post = get_post( $args[0] );
+ 		$post_type = get_post_type_object( $post->post_type );
+ 
+ 		$caps[] = $post_type->cap->publish_posts;
+ 		break;
  	case 'edit_post_meta':
  	case 'delete_post_meta':
  	case 'add_post_meta':
***************
*** 1138,1148 ****
  	case 'edit_files':
  	case 'edit_plugins':
  	case 'edit_themes':
! 		if ( defined('DISALLOW_FILE_EDIT') && DISALLOW_FILE_EDIT ) {
  			$caps[] = 'do_not_allow';
! 			break;
! 		}
! 		// Fall through if not DISALLOW_FILE_EDIT.
  	case 'update_plugins':
  	case 'delete_plugins':
  	case 'install_plugins':
--- 1197,1212 ----
  	case 'edit_files':
  	case 'edit_plugins':
  	case 'edit_themes':
! 		// Disallow the file editors.
! 		if ( defined( 'DISALLOW_FILE_EDIT' ) && DISALLOW_FILE_EDIT )
  			$caps[] = 'do_not_allow';
! 		elseif ( defined( 'DISALLOW_FILE_MODS' ) && DISALLOW_FILE_MODS )
! 			$caps[] = 'do_not_allow';
! 		elseif ( is_multisite() && ! is_super_admin( $user_id ) )
! 			$caps[] = 'do_not_allow';
! 		else
! 			$caps[] = $cap;
! 		break;
  	case 'update_plugins':
  	case 'delete_plugins':
  	case 'install_plugins':
***************
*** 1150,1172 ****
  	case 'delete_themes':
  	case 'install_themes':
  	case 'update_core':
! 		// Disallow anything that creates, deletes, or edits core, plugin, or theme files.
  		// Files in uploads are excepted.
! 		if ( defined('DISALLOW_FILE_MODS') && DISALLOW_FILE_MODS ) {
  			$caps[] = 'do_not_allow';
! 			break;
  		}
! 		// Fall through if not DISALLOW_FILE_MODS.
  	case 'delete_user':
  	case 'delete_users':
! 		// If multisite these caps are allowed only for super admins.
! 		if ( is_multisite() && !is_super_admin( $user_id ) ) {
  			$caps[] = 'do_not_allow';
! 		} else {
! 			if ( 'delete_user' == $cap )
! 				$cap = 'delete_users';
! 			$caps[] = $cap;
! 		}
  		break;
  	case 'create_users':
  		if ( !is_multisite() )
--- 1214,1244 ----
  	case 'delete_themes':
  	case 'install_themes':
  	case 'update_core':
! 		// Disallow anything that creates, deletes, or updates core, plugin, or theme files.
  		// Files in uploads are excepted.
! 		if ( defined( 'DISALLOW_FILE_MODS' ) && DISALLOW_FILE_MODS )
  			$caps[] = 'do_not_allow';
! 		elseif ( is_multisite() && ! is_super_admin( $user_id ) )
! 			$caps[] = 'do_not_allow';
! 		else
! 			$caps[] = $cap;
! 		break;
! 	case 'activate_plugins':
! 		$caps[] = $cap;
! 		if ( is_multisite() ) {
! 			// update_, install_, and delete_ are handled above with is_super_admin().
! 			$menu_perms = get_site_option( 'menu_items', array() );
! 			if ( empty( $menu_perms['plugins'] ) )
! 				$caps[] = 'manage_network_plugins';
  		}
! 		break;
  	case 'delete_user':
  	case 'delete_users':
! 		// If multisite only super admins can delete users.
! 		if ( is_multisite() && ! is_super_admin( $user_id ) )
  			$caps[] = 'do_not_allow';
! 		else
! 			$caps[] = 'delete_users'; // delete_user maps to delete_users.
  		break;
  	case 'create_users':
  		if ( !is_multisite() )
***************
*** 1176,1181 ****
--- 1248,1259 ----
  		else
  			$caps[] = 'do_not_allow';
  		break;
+ 	case 'manage_links' :
+ 		if ( get_option( 'link_manager_enabled' ) )
+ 			$caps[] = $cap;
+ 		else
+ 			$caps[] = 'do_not_allow';
+ 		break;
  	default:
  		// Handle meta capabilities for custom post types.
  		$post_type_meta_caps = _post_type_meta_capabilities();
***************
*** 1221,1241 ****
   * @return bool
   */
  function current_user_can_for_blog( $blog_id, $capability ) {
  	$current_user = wp_get_current_user();
  
  	if ( empty( $current_user ) )
  		return false;
  
- 	// Create new object to avoid stomping the global current_user.
- 	$user = new WP_User( $current_user->ID) ;
- 
- 	// Set the blog id. @todo add blog id arg to WP_User constructor?
- 	$user->for_blog( $blog_id );
- 
  	$args = array_slice( func_get_args(), 2 );
  	$args = array_merge( array( $capability ), $args );
  
! 	return call_user_func_array( array( &$user, 'has_cap' ), $args );
  }
  
  /**
--- 1299,1321 ----
   * @return bool
   */
  function current_user_can_for_blog( $blog_id, $capability ) {
+ 	if ( is_multisite() )
+ 		switch_to_blog( $blog_id );
+ 
  	$current_user = wp_get_current_user();
  
  	if ( empty( $current_user ) )
  		return false;
  
  	$args = array_slice( func_get_args(), 2 );
  	$args = array_merge( array( $capability ), $args );
  
! 	$can = call_user_func_array( array( $current_user, 'has_cap' ), $args );
! 
! 	if ( is_multisite() )
! 		restore_current_blog();
! 
! 	return $can;
  }
  
  /**
***************
*** 1251,1265 ****
  	if ( !$post = get_post($post) )
  		return false;
  
! 	$author = new WP_User( $post->post_author );
  
! 	if ( empty( $author->ID ) )
  		return false;
  
  	$args = array_slice( func_get_args(), 2 );
  	$args = array_merge( array( $capability ), $args );
  
! 	return call_user_func_array( array( &$author, 'has_cap' ), $args );
  }
  
  /**
--- 1331,1345 ----
  	if ( !$post = get_post($post) )
  		return false;
  
! 	$author = get_userdata( $post->post_author );
  
! 	if ( ! $author )
  		return false;
  
  	$args = array_slice( func_get_args(), 2 );
  	$args = array_merge( array( $capability ), $args );
  
! 	return call_user_func_array( array( $author, 'has_cap' ), $args );
  }
  
  /**
***************
*** 1273,1279 ****
   */
  function user_can( $user, $capability ) {
  	if ( ! is_object( $user ) )
! 		$user = new WP_User( $user );
  
  	if ( ! $user || ! $user->exists() )
  		return false;
--- 1353,1359 ----
   */
  function user_can( $user, $capability ) {
  	if ( ! is_object( $user ) )
! 		$user = get_userdata( $user );
  
  	if ( ! $user || ! $user->exists() )
  		return false;
***************
*** 1281,1287 ****
  	$args = array_slice( func_get_args(), 2 );
  	$args = array_merge( array( $capability ), $args );
  
! 	return call_user_func_array( array( &$user, 'has_cap' ), $args );
  }
  
  /**
--- 1361,1367 ----
  	$args = array_slice( func_get_args(), 2 );
  	$args = array_merge( array( $capability ), $args );
  
! 	return call_user_func_array( array( $user, 'has_cap' ), $args );
  }
  
  /**
***************
*** 1367,1378 ****
   * @return bool True if the user is a site admin.
   */
  function is_super_admin( $user_id = false ) {
! 	if ( $user_id )
! 		$user = new WP_User( $user_id );
! 	else
  		$user = wp_get_current_user();
  
! 	if ( ! $user->exists() )
  		return false;
  
  	if ( is_multisite() ) {
--- 1447,1458 ----
   * @return bool True if the user is a site admin.
   */
  function is_super_admin( $user_id = false ) {
! 	if ( ! $user_id || $user_id == get_current_user_id() )
  		$user = wp_get_current_user();
+ 	else
+ 		$user = get_userdata( $user_id );
  
! 	if ( ! $user || ! $user->exists() )
  		return false;
  
  	if ( is_multisite() ) {
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/category.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/category.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/category.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/category.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 36,42 ****
   * @param string|array $args Optional. Change the defaults retrieving categories.
   * @return array List of categories.
   */
! function &get_categories( $args = '' ) {
  	$defaults = array( 'taxonomy' => 'category' );
  	$args = wp_parse_args( $args, $defaults );
  
--- 36,42 ----
   * @param string|array $args Optional. Change the defaults retrieving categories.
   * @return array List of categories.
   */
! function get_categories( $args = '' ) {
  	$defaults = array( 'taxonomy' => 'category' );
  	$args = wp_parse_args( $args, $defaults );
  
***************
*** 78,84 ****
   * @param string $filter Optional. Default is raw or no WordPress defined filter will applied.
   * @return mixed Category data in type defined by $output parameter.
   */
! function &get_category( $category, $output = OBJECT, $filter = 'raw' ) {
  	$category = get_term( $category, 'category', $output, $filter );
  	if ( is_wp_error( $category ) )
  		return $category;
--- 78,84 ----
   * @param string $filter Optional. Default is raw or no WordPress defined filter will applied.
   * @return mixed Category data in type defined by $output parameter.
   */
! function get_category( $category, $output = OBJECT, $filter = 'raw' ) {
  	$category = get_term( $category, 'category', $output, $filter );
  	if ( is_wp_error( $category ) )
  		return $category;
***************
*** 165,174 ****
   *
   * @since 1.0.0
   *
!  * @param string $cat_name Optional. Default is 'General' and can be any category name.
   * @return int 0, if failure and ID of category on success.
   */
! function get_cat_ID( $cat_name='General' ) {
  	$cat = get_term_by( 'name', $cat_name, 'category' );
  	if ( $cat )
  		return $cat->term_id;
--- 165,174 ----
   *
   * @since 1.0.0
   *
!  * @param string $cat_name Category name.
   * @return int 0, if failure and ID of category on success.
   */
! function get_cat_ID( $cat_name ) {
  	$cat = get_term_by( 'name', $cat_name, 'category' );
  	if ( $cat )
  		return $cat->term_id;
***************
*** 185,191 ****
   */
  function get_cat_name( $cat_id ) {
  	$cat_id = (int) $cat_id;
! 	$category = &get_category( $cat_id );
  	if ( ! $category || is_wp_error( $category ) )
  		return '';
  	return $category->name;
--- 185,191 ----
   */
  function get_cat_name( $cat_id ) {
  	$cat_id = (int) $cat_id;
! 	$category = get_category( $cat_id );
  	if ( ! $category || is_wp_error( $category ) )
  		return '';
  	return $category->name;
***************
*** 249,255 ****
   * @param string|array $args Tag arguments to use when retrieving tags.
   * @return array List of tags.
   */
! function &get_tags( $args = '' ) {
  	$tags = get_terms( 'post_tag', $args );
  
  	if ( empty( $tags ) ) {
--- 249,255 ----
   * @param string|array $args Tag arguments to use when retrieving tags.
   * @return array List of tags.
   */
! function get_tags( $args = '' ) {
  	$tags = get_terms( 'post_tag', $args );
  
  	if ( empty( $tags ) ) {
***************
*** 280,286 ****
   * @param string $filter Optional. Default is raw or no WordPress defined filter will applied.
   * @return object|array Return type based on $output value.
   */
! function &get_tag( $tag, $output = OBJECT, $filter = 'raw' ) {
  	return get_term( $tag, 'post_tag', $output, $filter );
  }
  
--- 280,286 ----
   * @param string $filter Optional. Default is raw or no WordPress defined filter will applied.
   * @return object|array Return type based on $output value.
   */
! function get_tag( $tag, $output = OBJECT, $filter = 'raw' ) {
  	return get_term( $tag, 'post_tag', $output, $filter );
  }
  
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/category-template.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/category-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/category-template.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/category-template.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 41,47 ****
   */
  function get_category_parents( $id, $link = false, $separator = '/', $nicename = false, $visited = array() ) {
  	$chain = '';
! 	$parent = &get_category( $id );
  	if ( is_wp_error( $parent ) )
  		return $parent;
  
--- 41,47 ----
   */
  function get_category_parents( $id, $link = false, $separator = '/', $nicename = false, $visited = array() ) {
  	$chain = '';
! 	$parent = get_category( $id );
  	if ( is_wp_error( $parent ) )
  		return $parent;
  
***************
*** 73,79 ****
   */
  function get_the_category( $id = false ) {
  	$categories = get_the_terms( $id, 'category' );
! 	if ( ! $categories )
  		$categories = array();
  
  	$categories = array_values( $categories );
--- 73,79 ----
   */
  function get_the_category( $id = false ) {
  	$categories = get_the_terms( $id, 'category' );
! 	if ( ! $categories || is_wp_error( $categories ) )
  		$categories = array();
  
  	$categories = array_values( $categories );
***************
*** 135,141 ****
   */
  function get_the_category_by_ID( $cat_ID ) {
  	$cat_ID = (int) $cat_ID;
! 	$category = &get_category( $cat_ID );
  	if ( is_wp_error( $category ) )
  		return $category;
  	return $category->name;
--- 135,141 ----
   */
  function get_the_category_by_ID( $cat_ID ) {
  	$cat_ID = (int) $cat_ID;
! 	$category = get_category( $cat_ID );
  	if ( is_wp_error( $category ) )
  		return $category;
  	return $category->name;
***************
*** 1054,1082 ****
   *
   * @since 2.5.0
   *
!  * @param int $id Post ID.
   * @param string $taxonomy Taxonomy name.
   * @return array|bool False on failure. Array of term objects on success.
   */
! function get_the_terms( $id, $taxonomy ) {
! 	global $post;
! 
!  	$id = (int) $id;
! 
! 	if ( !$id ) {
! 		if ( empty( $post->ID ) )
! 			return false;
! 		else
! 			$id = (int) $post->ID;
! 	}
  
! 	$terms = get_object_term_cache( $id, $taxonomy );
  	if ( false === $terms ) {
! 		$terms = wp_get_object_terms( $id, $taxonomy );
! 		wp_cache_add($id, $terms, $taxonomy . '_relationships');
  	}
  
! 	$terms = apply_filters( 'get_the_terms', $terms, $id, $taxonomy );
  
  	if ( empty( $terms ) )
  		return false;
--- 1054,1074 ----
   *
   * @since 2.5.0
   *
!  * @param mixed $post Post ID or object.
   * @param string $taxonomy Taxonomy name.
   * @return array|bool False on failure. Array of term objects on success.
   */
! function get_the_terms( $post, $taxonomy ) {
! 	if ( ! $post = get_post( $post ) )
! 		return false;
  
! 	$terms = get_object_term_cache( $post->ID, $taxonomy );
  	if ( false === $terms ) {
! 		$terms = wp_get_object_terms( $post->ID, $taxonomy );
! 		wp_cache_add($post->ID, $terms, $taxonomy . '_relationships');
  	}
  
! 	$terms = apply_filters( 'get_the_terms', $terms, $post->ID, $taxonomy );
  
  	if ( empty( $terms ) )
  		return false;
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-feed.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-feed.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-feed.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-feed.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 85,94 ****
  				$this->status_code = wp_remote_retrieve_response_code( $res );
  			}
  		} else {
! 			if ( ! $this->body = file_get_contents($url) ) {
  				$this->error = 'file_get_contents could not read the file';
  				$this->success = false;
  			}
  		}
  	}
  }
--- 85,129 ----
  				$this->status_code = wp_remote_retrieve_response_code( $res );
  			}
  		} else {
! 			if ( ! file_exists($url) || ( ! $this->body = file_get_contents($url) ) ) {
  				$this->error = 'file_get_contents could not read the file';
  				$this->success = false;
  			}
  		}
  	}
  }
+ 
+ /**
+  * WordPress SimplePie Sanitization Class
+  *
+  * Extension of the SimplePie_Sanitize class to use KSES, because
+  * we cannot universally count on DOMDocument being available
+  *
+  * @package WordPress
+  * @since 3.5.0
+  */
+ class WP_SimplePie_Sanitize_KSES extends SimplePie_Sanitize {
+ 	public function sanitize( $data, $type, $base = '' ) {
+ 		$data = trim( $data );
+ 		if ( $type & SIMPLEPIE_CONSTRUCT_MAYBE_HTML ) {
+ 			if (preg_match('/(&(#(x[0-9a-fA-F]+|[0-9]+)|[a-zA-Z0-9]+)|<\/[A-Za-z][^\x09\x0A\x0B\x0C\x0D\x20\x2F\x3E]*' . SIMPLEPIE_PCRE_HTML_ATTRIBUTE . '>)/', $data)) {
+ 				$type |= SIMPLEPIE_CONSTRUCT_HTML;
+ 			}
+ 			else {
+ 				$type |= SIMPLEPIE_CONSTRUCT_TEXT;
+ 			}
+ 		}
+ 		if ( $type & SIMPLEPIE_CONSTRUCT_BASE64 ) {
+ 			$data = base64_decode( $data );
+ 		}
+ 		if ( $type & ( SIMPLEPIE_CONSTRUCT_HTML | SIMPLEPIE_CONSTRUCT_XHTML ) ) {
+ 			$data = wp_kses_post( $data );
+ 			if ( $this->output_encoding !== 'UTF-8' ) {
+ 				$data = $this->registry->call( 'Misc', 'change_encoding', array( $data, 'UTF-8', $this->output_encoding ) );
+ 			}
+ 			return $data;
+ 		} else {
+ 			return parent::sanitize( $data, $type, $base );
+ 		}
+ 	}
+ }
